﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF.Theming.ExpressionLight;

namespace Wpf_C1DataGrid
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();

            C1ThemeExpressionLight theme = new C1ThemeExpressionLight();
            theme.Apply(this);

            c1DataGrid.LoadedCellPresenter += c1DataGrid_LoadedCellPresenter;
        }
        
        void c1DataGrid_LoadedCellPresenter(object sender, C1.WPF.DataGrid.DataGridCellEventArgs e)
        {
            if (e.Cell.Row.Index==7 && e.Cell.Column.Index == 1)
            {
                Dispatcher.BeginInvoke(new Action(
                    delegate()
                    {
                        var ob=e.Cell.Presenter.Content as ContentControl;
                        Button b = VisualTreeHelper.GetChild((VisualTreeHelper.GetChild(ob, 0) as ContentPresenter),0) as Button;
                        b.Click += btnSubmit_Click;
                    }));
            }
        }

        private void btnSubmit_Click(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(
                    delegate()
                    {
                        var ob = c1DataGrid[0,1].Presenter.Content as ContentControl;
                        TextBox txt = VisualTreeHelper.GetChild((VisualTreeHelper.GetChild(ob, 0) as ContentPresenter), 0) as TextBox;
                        string name = txt.Text;
                        MessageBox.Show("Welcome " + name);
                    }));
        }
    }

    public class ViewModel
    {
        public ObservableCollection<string> ControlTypes
        {
            get;
            set;
        }
        public ViewModel()
        {
            ControlTypes = new ObservableCollection<string>();
            ControlTypes.Add("Name");
            ControlTypes.Add("Designation");
            ControlTypes.Add("Company");
            ControlTypes.Add("Gender");
            ControlTypes.Add("Age");
            ControlTypes.Add("IsActive");
            ControlTypes.Add("Address"); 
            ControlTypes.Add("");                    
        }
    }

    public class TextInputToVisibilityConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            // Always test MultiValueConverter inputs for non-null
            // (to avoid crash bugs for views in the designer)
            if (values[0] is bool && values[1] is bool)
            {
                bool hasText = !(bool)values[0];
                bool hasFocus = (bool)values[1];

                if (hasFocus || hasText)
                    return Visibility.Collapsed;
            }

            return Visibility.Visible;
        }


        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}

